#include <fstream.h>

long cmmdc(long a, long b)
{
	if (b == 0) return a;
	return cmmdc(b, a % b);
}

int N, P[502];
long prims[52], T[502];
long result = 1;

void sort(int st, int dr)
{
	long pivot = prims[st];
	int i = st - 1, j = dr + 1;

	do
	{
		do { ++i; } while (prims[i] < pivot);
		do { --j; } while (prims[j] > pivot);
		if ( i <= j)
		{
			long aux = prims[i];
			prims[i] = prims[j];
			prims[j] = aux;
		}
	} while (i <= j);

	if (i <= dr) sort(i, dr);
	if (st <= j) sort(st, j);
}

int main()
{
	ifstream fin("sport.in");
	ofstream fout("sport.out");

	int i;

	fin >> N;
	for (i = 1; i <= N; ++i)
	{
		fin >> P[i];
		T[i] = -1;
	}

	for (i = 1; i <= N; ++i)
	{
		if (T[i] != -1) continue;

		long now = P[P[i]], times = 1;

		while (now != P[i])
		{
			now = P[now];
			++times;
		}

		T[now] = times;

		now = P[P[i]];
		while (now != P[i])
		{
			T[now] = times;
			now = P[now];
		}

		long aux = cmmdc(result, times);
		result /= aux;
		result *= times;
	}

	fout << result << '\n';

	long j, cop = result;
	for (j = 2; j * j <= result; ++j)
	{
		if (cop % j == 0)
		{
			prims[++prims[0]] = 1;
			while (cop % j == 0)
			{
				prims[prims[0]] *= j;
				cop /= j;
			}
		}
		if (j % 2 == 1) ++j;
	}
	if (cop != 1)
		prims[++prims[0]] = cop;

	sort(1, prims[0]);

	long sum = 0;
	for (i = 1; i <= prims[0]; ++i)
		sum += prims[i];

	for (i = 1; i <= N - sum; ++i)
		fout << i << ' ';

	int now = N - sum + 1;
	for (i = 1; i <= prims[0]; ++i)
	{
		for (j = 1; j < prims[i]; ++j)
		{
			fout << now + 1 << ' ';
			++now;
		}
		fout << now - prims[i] + 1 << ' ';
		++now;
	}

	fin.close();
	fout.close();

	return 0;
}